import { Meta, Preview, Props, Story } from '@storybook/addon-docs/blocks';
import { DependenciesTable } from 'storybook-addon-deps/blocks';
import { withKnobs, boolean, select, object } from '@storybook/addon-knobs';

import AIconDropdownUi from './AIconDropdownUi.vue';

<Meta
  title="Core/Molecules/AIconDropdownUi"
  component={AIconDropdownUi}
  parameters={{ component: AIconDropdownUi }}
  decorators={[
    () => ({ template: '<div class="flex justify-center items-start h-48"><story /></div>' })
  ]}
/>

# A-Icon-Dropdown-Ui

A dropdown with an icon that reveals the panel.

<Preview>
  <Story name="default" decorators={[withKnobs]}>
    {{
      components: { AIconDropdownUi },
      props: {
        position: {
          default: select(
            'position',
            {
              left: 'left',
              center: 'center',
              right: 'right',
            },
            'right',
            'Props'
          ),
        },
        showPanel: { default: boolean('showPanel', true, 'Props') },
        styles: {
          default: () => object(
            'CSS Variables',
            {
              '--a-icon-dropdown-ui--panel--mt': '0.5rem',
              '--a-icon-dropdown-ui--panel--min-w': '12rem',
              '--a-icon-dropdown-ui--panel--bg-color': '#ffffff',
              '--a-icon-dropdown-ui--panel--rounded': '0.25rem',
            },
            'Styles'
          ),
        },
      },
      template: `
        <a-icon-dropdown-ui :position="position" :show-panel="showPanel" :style="styles">
          <template #icon>
            <button
              class="flex text-sm border-2 border-transparent rounded-full focus:outline-none focus:border-gray-300 transition duration-150 ease-in-out"
              @click="showPanel = !showPanel"
            >
              <img
                class="block h-10 w-10 rounded-full"
                src='https://secure.gravatar.com/avatar/f925124b0eed1eeab8513016914b9150?s=117&d=identicon'
                alt="User avatar"
              />
            </button>
          </template>
          <template #panel>
            <a-stack-l class="reset space-y-0">
              <a href="#" role="menuitem" class="block px-4 py-2 text-sm leading-5 text-gray-700 hover:bg-gray-100 focus:outline-none focus:bg-gray-100 transition duration-150 ease-in-out">
                Your Profile
              </a>
              <a href="#" role="menuitem" class="block px-4 py-2 text-sm leading-5 text-gray-700 hover:bg-gray-100 focus:outline-none focus:bg-gray-100 transition duration-150 ease-in-out">
                Settings
              </a>
              <a href="#" role="menuitem" class="block px-4 py-2 text-sm leading-5 text-gray-700 hover:bg-gray-100 focus:outline-none focus:bg-gray-100 transition duration-150 ease-in-out">
                Sign out
              </a>
            </a-stack-l>
          </template>
        </a-icon-dropdown-ui>
      `,
    }}
  </Story>
</Preview>

## API

<Props of={AIconDropdownUi} />

## Installation

```bash
yarn add -E @bit/adakode.ak-ui.core.molecules.a-icon-dropdown
```

## Usage

```html
<!-- Custom Dropdown: a user profile dropdown -->
<a-icon-dropdown-ui position="right" :show-panel="showUserMenu">
  <template #icon>
    <button
      id="user-menu"
      class="flex text-sm border-2 border-transparent rounded-full focus:outline-none focus:border-gray-300 transition duration-150 ease-in-out"
      aria-label="User menu"
      aria-haspopup="true"
      v-click-outside="showUserMenu = false"
      @click="showUserMenu = !showUserMenu"
    >
      <svg-icon name="app/user-avatar" class="h-8 w-8 rounded-full" />
    </button>
  </template>
  <template #panel>
    <a-stack-l class="reset space-y-0">
      <a-link-ui
        to="/profile"
        role="menuitem"
        class="block px-4 py-2 text-sm leading-5 text-gray-700 hover:bg-gray-100 focus:outline-none focus:bg-gray-100 transition duration-150 ease-in-out"
      >
        Your Profile
      </a-link-ui>
      <a-link-ui
        to="/settings"
        role="menuitem"
        class="block px-4 py-2 text-sm leading-5 text-gray-700 hover:bg-gray-100 focus:outline-none focus:bg-gray-100 transition duration-150 ease-in-out"
      >
        Settings
      </a-link-ui>
      <a-link-ui
        to="/logout"
        role="menuitem"
        class="block px-4 py-2 text-sm leading-5 text-gray-700 hover:bg-gray-100 focus:outline-none focus:bg-gray-100 transition duration-150 ease-in-out"
      >
        Sign out
      </a-link-ui>
    </a-stack-l>
  </template>
</a-icon-dropdown-ui>
```

## Customization

There are several ways to customize the look and feel of the component,
depending on the desired scope of the customization.

### Global Customization

To customize the look and feel of **every single instance** of the component
create a css file defining a class named after the kebab-case version of the component name
and define any of the custom properties below:

| CSS variable                               |   default | design token                    |
| :----------------------------------------- | --------: | :------------------------------ |
| `--a-icon-dropdown-ui--panel--mt`          |  `0.5rem` | `theme('spacing.2')`            |
| `--a-icon-dropdown-ui--panel--min-w`       |   `12rem` | `theme('minWidth.xl')`          |
| `--a-icon-dropdown-ui--panel--bg-color`    | `#ffffff` | `theme('colors.white')`         |
| `--a-icon-dropdown-ui--panel--rounded`     | `0.25rem` | `theme('borderRadius.default')` |

These are the steps:

```bash
mkdir -p src/assets/styles/components/ui/core/molecules && touch $_/AIconDropdownUi.css
```

```css
/* <rootDir>/src/assets/styles/components/index.css */
@import './ui/core/molecules/AIconDropdownUi.css';
```

```css
/* <rootDir>/src/assets/styles/components/ui/core/molecules/AIconDropdownUi.css */
.a-icon-dropdown-ui {
  --a-icon-dropdown-ui--panel--mt: theme('spacing.2');
  --a-icon-dropdown-ui--panel--min-w: theme('minWidth.xl');
  --a-icon-dropdown-ui--panel--bg-color: theme('colors.white');
  --a-icon-dropdown-ui--panel--rounded: theme('borderRadius.default');
}
```

### Scoped Customization

To customize the look and feel of a **group of instances** of the component
augment the specificity of the component class with a scoping data attribute:

```css
/* <rootDir>/src/assets/styles/components/ui/core/molecules/AIconDropdownUi.css */
.a-icon-dropdown-ui[data-theme='dark'] {
  --a-icon-dropdown-ui--panel--bg-color: theme('colors.gray.800');
}
.a-icon-dropdown-ui[data-theme='light'] {
  --a-icon-dropdown-ui--panel--bg-color: theme('colors.gray.50');
}
```

```html
<!-- <rootDir>/src/components/path/to/the/ConsumerComponent.vue -->
<a-icon-dropdown-ui :data-theme="theme">
  <template #icon><!-- An icon button --></template>
  <template #panel>
    <a-stack-l class="reset space-y-0">
      <a-link-ui><!-- Panel entry --></a-link-ui>
      <a-link-ui><!-- Panel entry --></a-link-ui>
      <a-link-ui><!-- Panel entry --></a-link-ui>
    </a-stack-l>
  </template>
</a-icon-dropdown-ui>
```

### Instance Customization

To customize the look and feel of a **single instance** of the component
you can define the desired CSS variables inline:

```html
<!-- Using CSS variables -->
<a-icon-dropdown-ui
  :style="{
    '--a-icon-dropdown-ui--panel--mt': '0.5rem',
    '--a-icon-dropdown-ui--panel--min-w': '12rem',
    '--a-icon-dropdown-ui--panel--bg-color': '#ffffff',
    '--a-icon-dropdown-ui--panel--rounded': '0.25rem',
  }"
>
  <template #icon><!-- An icon button --></template>
  <template #panel>
    <a-stack-l class="reset space-y-0">
      <a-link-ui><!-- Panel entry --></a-link-ui>
      <a-link-ui><!-- Panel entry --></a-link-ui>
      <a-link-ui><!-- Panel entry --></a-link-ui>
    </a-stack-l>
  </template>
</a-icon-dropdown-ui>
```

## Dependencies

<DependenciesTable
  titleDependencies="Dependencies"
  titleDependents="Dependents"
  of={AIconDropdownUi}
/>

## Links

Source: https://gitlab.com/adakodecoop/coop/adakode-ui/-/tree/master/src/components/ui/core/molecules/AIconDropdown  
Bit: https://bit.dev/adakode/ak-ui/core/molecules/a-icon-dropdown
